/* --------------------------------------------------------------------------
 *
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 *
 * File: Clipboard.h
 * Description: an interface to a clipboard
 * Warning: unfinished, just for system clipboard
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_CLIPBOARD_H__
#define __ETK_CLIPBOARD_H__

#include <etk/app/Messenger.h>
#include <etk/support/Locker.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EClipboard {
public:
	EClipboard(const char *name);
	virtual ~EClipboard();

	const char	*Name() const;

	euint32		LocalCount() const;
	euint32		SystemCount() const;
	e_status_t	StartWatching(const EMessenger &target);
	e_status_t	StopWatching(const EMessenger &target);

	bool		Lock();
	void		Unlock();
	eint64		CountLocks() const;

	e_status_t	Clear();
	e_status_t	Commit();
	e_status_t	Revert();

	EMessenger	DataSource() const;
	EMessage	*Data() const;

private:
	char *fName;
	ELocker fLocker;
	EMessage *fData;
};

#endif /* __cplusplus */

#endif /* __ETK_CLIPBOARD_H__ */

