/* --------------------------------------------------------------------------
 *
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 *
 * File: Cursor.h
 * Description: mouse cursor for application
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_CURSOR_H__
#define __ETK_CURSOR_H__

#include <etk/support/Archivable.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ECursor : public EArchivable {
public:
	ECursor(const void *cursorData);
	ECursor(const ECursor &cursor);
	virtual ~ECursor();

	ECursor		&operator=(const ECursor &from);
	bool		operator==(const ECursor &other) const;
	bool		operator!=(const ECursor &other) const;

	const void 	*Data() const;
	euint32		DataLength() const;

	euint8		ColorDepth() const;
	euint8		Width() const;
	euint8		Height() const;

	euint16		Spot() const;
	euint8		SpotX() const;
	euint8		SpotY() const;

	const void	*Bits() const;
	const void	*Mask() const;

private:
	void *fData;
};


inline euint8 ECursor::SpotX() const
{
	return(Spot() >> 8);
}


inline euint8 ECursor::SpotY() const
{
	return(Spot() & 0xff);
}


extern _IMPEXP_ETK const ECursor *E_CURSOR_SYSTEM_DEFAULT;
extern _IMPEXP_ETK const ECursor *E_CURSOR_HAND;
extern _IMPEXP_ETK const ECursor *E_CURSOR_HAND_MOVE;
extern _IMPEXP_ETK const ECursor *E_CURSOR_I_BEAM;


#endif /* __cplusplus */

#endif /* __ETK_CURSOR_H__ */

