/* --------------------------------------------------------------------------
 *
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 *
 * File: MessageQueue.h
 * Description: The first-in/first-out queue of messages for Looper
 *
 * --------------------------------------------------------------------------*/

#ifndef __ETK_MESSAGE_QUEUE_H__
#define __ETK_MESSAGE_QUEUE_H__

#include <etk/support/List.h>
#include <etk/app/Message.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EMessageQueue {
public:
	EMessageQueue();
	virtual ~EMessageQueue();

	// add "an_event" to the queue and delete it automatically when FAILED
	bool		AddMessage(EMessage *an_event);

	// remove "an_event" from the queue and delete it automatically when FOUNDED
	bool		RemoveMessage(EMessage *an_event);

	// return the FIRST message and detach from the queue, you should "delete" by yourself
	EMessage	*NextMessage();

	EMessage	*FindMessage(eint32 index) const;
	EMessage	*FindMessage(euint32 what, eint32 fromIndex = 0) const;
	EMessage	*FindMessage(euint32 what, eint32 fromIndex, eint32 count) const;
	eint32		IndexOfMessage(EMessage *an_event) const;

	eint32		CountMessages() const;
	bool		IsEmpty() const;

	bool		Lock();
	void		Unlock();
	e_status_t	LockWithTimeout(e_bigtime_t microseconds_timeout);

private:
	EList fMessagesList;
	void *fLocker;
};

#endif /* __cplusplus */

#endif /* __ETK_MESSAGE_QUEUE_H__ */



