#ifndef __ETK_BOX_H__
#define __ETK_BOX_H__

#include <etk/interface/View.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EBox : public EView {
public:
	EBox(ERect frame,
	     const char *name = NULL,
	     euint32 resizingMode = E_FOLLOW_LEFT | E_FOLLOW_TOP,
	     euint32 flags = E_WILL_DRAW | E_FRAME_EVENTS | E_NAVIGABLE_JUMP,
	     e_border_style border = E_FANCY_BORDER);
	virtual ~EBox();

	// Archiving
	EBox(EMessage *from);
	virtual e_status_t Archive(EMessage *into, bool deep = true) const;
	static EArchivable *Instantiate(EMessage *from);

	virtual void	SetBorder(e_border_style border);
	e_border_style	Border() const;

	void		SetLabelAlignment(e_alignment labelAlignment);
	e_alignment	LabelAlignment() const;

	void		SetLabel(const char *label);
	e_status_t	SetLabel(EView *viewLabel);
	const char	*Label() const;
	EView		*LabelView() const;

	ERect		ContentBounds() const;

	virtual	void	Draw(ERect updateRect);
	virtual	void	FrameResized(float new_width, float new_height);

	virtual void	ResizeToPreferred();
	virtual	void	GetPreferredSize(float *width, float *height);

protected:
	virtual void	ChildRemoving(EView *child);

private:
	EView *fLabelView;
	e_border_style fBorder;
	e_alignment fAlignment;

	void ReAdjustLabel();
};

#endif /* __cplusplus */

#endif /* __ETK_BOX_H__ */

