/* --------------------------------------------------------------------------
 * 
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 * 
 * File: CheckBox.h
 * Description: ECheckBox --- A view could change it's state when click the box
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_CHECK_BOX_H__
#define __ETK_CHECK_BOX_H__

#include <etk/interface/Control.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ECheckBox : public EControl {
public:
	ECheckBox(ERect frame,
		  const char *name,
		  const char *label,
		  EMessage *message,
		  euint32 resizeMode = E_FOLLOW_LEFT | E_FOLLOW_TOP,
		  euint32 flags = E_WILL_DRAW | E_NAVIGABLE);
	virtual ~ECheckBox();

	// Archiving
	ECheckBox(EMessage *from);
	virtual e_status_t Archive(EMessage *into, bool deep = true) const;
	static EArchivable *Instantiate(EMessage *from);

	virtual void	SetLabel(const char *label);

	virtual	void	Draw(ERect updateRect);
	virtual	void	MouseDown(EPoint where);
	virtual	void	KeyDown(const char *bytes, eint32 numBytes);
	virtual void	SetFont(const EFont *font, euint8 mask = E_FONT_ALL);
	virtual	void	WindowActivated(bool state);

	virtual	void	GetPreferredSize(float *width, float *height);
};

#endif /* __cplusplus */

#endif /* __ETK_CHECK_BOX_H__ */

