/* --------------------------------------------------------------------------
 *
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 *
 * File: ColorControl.h
 * Description: EColorControl --- Displays a palette of selectable colors
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_COLOR_CONTROL_H__
#define __ETK_COLOR_CONTROL_H__

#include <etk/interface/Control.h>

#ifdef __cplusplus /* Just for C++ */

class EBitmap;

class _IMPEXP_ETK EColorControl : public EControl {
public:
	EColorControl(EPoint leftTop, const char *name, EMessage *message = NULL, bool bufferedDrawing = false);
	virtual ~EColorControl();

	virtual void	SetValue(eint32 color);
	void		SetValue(e_rgb_color color);
	e_rgb_color	ValueAsColor();

	virtual	void	Draw(ERect updateRect);
	virtual	void	MouseDown(EPoint where);
	virtual	void	GetPreferredSize(float *width, float *height);

private:
	EBitmap *fBitmap;

	ERect _MarkFrame(ERect colorFrame, euint8 channel);
	ERect _ColorsFrame();
	ERect _DescriptionFrame();

	void _DrawColors(ERect updateRect);
	void _DrawDescription(ERect updateRect);
};


#endif /* __cplusplus */

#endif /* __ETK_COLOR_CONTROL_H__ */

