#ifndef __ETK_CONTROL_H__
#define __ETK_CONTROL_H__

#include <etk/interface/View.h>
#include <etk/app/Invoker.h>

#ifdef __cplusplus /* Just for C++ */

enum {
	E_CONTROL_OFF = 0,
	E_CONTROL_ON = 1
};

class _IMPEXP_ETK EControl : public EView, public EInvoker {
public:
	EControl(ERect frame,
		 const char *name,
		 const char *label,
		 EMessage *message,
		 euint32 resizeMode,
		 euint32 flags);
	virtual ~EControl();

	// Archiving
	EControl(EMessage *from);
	virtual e_status_t Archive(EMessage *into, bool deep = true) const;
	static EArchivable *Instantiate(EMessage *from);

	virtual void SetLabel(const char *label);
	const char* Label() const;

	virtual void SetValue(eint32 value);
	eint32 Value() const;

	virtual e_status_t Invoke(const EMessage *msg = NULL);

	virtual void AttachedToWindow();
	virtual void DetachedFromWindow();

	virtual	void MakeFocus(bool focusState = true);

protected:
	bool IsFocusChanging() const;
	void SetValueNoUpdate(eint32 value);

private:
	char *fLabel;
	eint32 fValue;
	bool fFocusChanging;
};

#endif /* __cplusplus */

#endif /* __ETK_CONTROL_H__ */

