#ifndef __ETK_MENU_BAR_H__
#define __ETK_MENU_BAR_H__

#include <etk/interface/Menu.h>

#ifdef __cplusplus /* Just for C++ */

typedef enum e_menu_bar_border {
	E_BORDER_NONE = 0,
	E_BORDER_FRAME,
	E_BORDER_CONTENTS,
	E_BORDER_EACH_ITEM
} e_menu_bar_border;

class _IMPEXP_ETK EMenuBar : public EMenu {
public:
	EMenuBar(ERect frame, const char *title,
		 euint32 resizeMode = E_FOLLOW_LEFT_RIGHT | E_FOLLOW_TOP,
		 e_menu_layout layout = E_ITEMS_IN_ROW,
		 bool resizeToFit = true);
	virtual ~EMenuBar();

	// Archiving
	EMenuBar(EMessage *from);
	virtual e_status_t Archive(EMessage *into, bool deep = true) const;
	static EArchivable *Instantiate(EMessage *from);

	virtual	void		SetBorder(e_menu_bar_border border);
	e_menu_bar_border	Border() const;

	virtual	void		Draw(ERect updateRect);

	virtual void		MessageReceived(EMessage *msg);
	virtual	void		MouseDown(EPoint where);
	virtual	void		MouseUp(EPoint where);
	virtual	void		MouseMoved(EPoint where, euint32 code, const EMessage *a_message);
	virtual	void		KeyDown(const char *bytes, eint32 numBytes);
	virtual	void		KeyUp(const char *bytes, eint32 numBytes);

	virtual	void		MakeFocus(bool focusState = true);

protected:
	virtual void		ItemInvoked(EMenuItem *item);

private:
	e_menu_bar_border fBorder;
};

#endif /* __cplusplus */

#endif /* __ETK_MENU_BAR_H__ */

