#ifndef __ETK_POINT_H__
#define __ETK_POINT_H__

#include <etk/support/SupportDefs.h>

#ifdef __cplusplus /* Just for C++ */

class ERect;

class _IMPEXP_ETK EPoint {
public:
	float x;
	float y;

	EPoint();
	EPoint(float X, float Y);
	EPoint(const EPoint &pt);
		
	EPoint &operator=(const EPoint &from);
	void Set(float X, float Y);

	void ConstrainTo(ERect rect);

	void Ceil();
	void Floor();
	void Round();

	EPoint& FloorSelf();
	EPoint FloorCopy() const;
	EPoint& CeilSelf();
	EPoint CeilCopy() const;
	EPoint& RoundSelf();
	EPoint RoundCopy() const;

	EPoint operator+(const EPoint &plus) const;
	EPoint operator-(const EPoint &minus) const;
	EPoint& operator+=(const EPoint &plus);
	EPoint& operator-=(const EPoint &minus);

	bool operator!=(const EPoint &pt) const;
	bool operator==(const EPoint &pt) const;

	void PrintToStream() const;
};

extern _IMPEXP_ETK const EPoint E_ORIGIN;

#endif /* __cplusplus */

#endif /* __ETK_POINT_H__ */

