#ifndef __ETK_POLYGON_H__
#define __ETK_POLYGON_H__

#include <etk/interface/Rect.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EPolygon {
public:
	EPolygon(const EPoint *pts, eint32 nPts);
	EPolygon();
	EPolygon(const EPolygon *poly);
	virtual ~EPolygon();

	EPolygon	&operator=(const EPolygon &poly);
	ERect		Frame() const;
	bool		AddPoints(const EPoint *pts, eint32 nPts);
	eint32		CountPoints() const;
	bool		MapTo(ERect srcRect, ERect dstRect);

	const EPoint	*Points() const;
	void		PrintToStream() const;

private:
	ERect fBounds;
	eint32 fCount;
	EPoint *fPts;
};

#endif /* __cplusplus */

#endif /* __ETK_POLYGON_H__ */

