#ifndef __ETK_POP_UP_MENU_H__
#define __ETK_POP_UP_MENU_H__

#include <etk/support/Locker.h>
#include <etk/interface/Menu.h>
#include <etk/interface/Window.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EPopUpMenu : public EMenu {
public:
	EPopUpMenu(const char *title,
		   bool radioMode = true,
		   bool labelFromMarked = true,
		   e_menu_layout layout = E_ITEMS_IN_COLUMN);
	virtual ~EPopUpMenu();

	// Archiving
	EPopUpMenu(EMessage *from);
	virtual e_status_t Archive(EMessage *into, bool deep = true) const;
	static EArchivable *Instantiate(EMessage *from);

	// "could_proxy_when_sync" must be "true" when it called synchronously from looper of EApplication!
	EMenuItem*	Go(EPoint where,
			   bool delivers_message_when_sync = false,
			   bool open_anyway = false,
			   bool asynchronous = false,
			   bool could_proxy_when_sync = false);

	void		SetAsyncAutoDestruct(bool state);
	bool		AsyncAutoDestruct() const;

	virtual void	MessageReceived(EMessage *msg);
	virtual	void	MouseUp(EPoint where);

private:
	friend class EMenu;

	EMenuItem *fSelectedItem;
	bool fAutoDestruct;
	bool IsPopUpByGo() const;
};

#endif /* __cplusplus */

#endif /* __ETK_POP_UP_MENU_H__ */

