/* --------------------------------------------------------------------------
 * 
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 * 
 * File: RadioButton.h
 * Description: ERadioButton --- Radio buttons within their parent only one be on
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_RADIO_BUTTON_H__
#define __ETK_RADIO_BUTTON_H__

#include <etk/interface/Control.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ERadioButton : public EControl {
public:
	ERadioButton(ERect frame,
		     const char *name,
		     const char *label,
		     EMessage *message,
		     euint32 resizeMode = E_FOLLOW_LEFT | E_FOLLOW_TOP,
		     euint32 flags = E_WILL_DRAW | E_NAVIGABLE);
	virtual ~ERadioButton();

	// Archiving
	ERadioButton(EMessage *from);
	virtual e_status_t Archive(EMessage *into, bool deep = true) const;
	static EArchivable *Instantiate(EMessage *from);

	virtual void	SetLabel(const char *label);

	virtual	void	Draw(ERect updateRect);
	virtual	void	MouseDown(EPoint where);
	virtual	void	KeyDown(const char *bytes, eint32 numBytes);
	virtual void	SetFont(const EFont *font, euint8 mask = E_FONT_ALL);
	virtual	void	WindowActivated(bool state);

	virtual void	SetValue(eint32 value);
	virtual	void	GetPreferredSize(float *width, float *height);
};

#endif /* __cplusplus */

#endif /* __ETK_RADIO_BUTTON_H__ */

