/* --------------------------------------------------------------------------
 *
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 *
 * File: TextControl.h
 * Description: ETextControl --- display a labeled field could deliver a message as modifying
 *
 * --------------------------------------------------------------------------*/

#ifndef __ETK_TEXT_CONTROL_H__
#define __ETK_TEXT_CONTROL_H__

#include <etk/interface/TextEditable.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ETextControl : public ETextEditable {
public:
	ETextControl(ERect frame,
		     const char *name,
		     const char *label,
		     const char *text,
		     EMessage *message,
		     euint32 resizeMode = E_FOLLOW_LEFT | E_FOLLOW_TOP,
		     euint32 flags = E_WILL_DRAW | E_FRAME_EVENTS | E_NAVIGABLE);
	virtual ~ETextControl();

	virtual void	SetDivider(float divider);
	float		Divider() const;

	virtual void	SetAlignment(e_alignment forLabel, e_alignment forText);
	void		GetAlignment(e_alignment *forLabel, e_alignment *forText) const;

	virtual void	SetModificationMessage(EMessage *msg);
	EMessage	*ModificationMessage() const;

	virtual void	SetLabel(const char *label);
	virtual	void	Draw(ERect updateRect);
	virtual	void	GetPreferredSize(float *width, float *height);
	virtual	void	KeyDown(const char *bytes, eint32 numBytes);

private:
	e_alignment fLabelAlignment;
	float fDivider;
	EMessage *fModificationMessage;
	virtual void TextModified();
};

#endif /* __cplusplus */

#endif /* __ETK_TEXT_CONTROL_H__ */

