#ifndef __ETK_OS_H__
#define __ETK_OS_H__

#include <etk/support/SupportDefs.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef e_status_t (*e_thread_func)(void*);

/* time functions */
_IMPEXP_ETK e_status_t	e_snooze(e_bigtime_t microseconds);

#define E_SYSTEM_TIMEBASE	(0)
#define E_REAL_TIME_TIMEBASE	(1)
_IMPEXP_ETK e_status_t	e_snooze_until(e_bigtime_t time, int timebase);

_IMPEXP_ETK euint32	e_real_time_clock(void);
_IMPEXP_ETK e_bigtime_t	e_real_time_clock_usecs(void);
_IMPEXP_ETK e_bigtime_t	e_system_time(void); /* time since booting in microseconds */

#define E_OS_NAME_LENGTH					32
#define E_INFINITE_TIMEOUT					E_MAXINT64

#define E_READ_AREA						1
#define E_WRITE_AREA						2

#define E_LOW_PRIORITY						5
#define E_NORMAL_PRIORITY					10
#define E_DISPLAY_PRIORITY					15
#define	E_URGENT_DISPLAY_PRIORITY				20
#define	E_REAL_TIME_DISPLAY_PRIORITY				100
#define	E_URGENT_PRIORITY					110
#define E_REAL_TIME_PRIORITY					120

/* flags for semaphore control */
enum {
	E_CAN_INTERRUPT		= 1,	/* semaphore can be interrupted by a signal */
	E_DO_NOT_RESCHEDULE	= 2,	/* release() without rescheduling */
	E_TIMEOUT		= 8,	/* honor the (relative) timeout parameter */
	E_RELATIVE_TIMEOUT	= 8,
	E_ABSOLUTE_TIMEOUT	= 16	/* honor the (absolute) timeout parameter */
};

#ifdef __cplusplus
} /* extern "C" */
#endif /* __cplusplus */


#endif /* __ETK_OS_H__ */

