/* --------------------------------------------------------------------------
 * 
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 * 
 * $COPYING
 *
 * File: ArcGenerator.h
 * Description: EArcGenerator --- Pixel generator for zero-width-arc-drawing
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_ARC_GENERATOR_H__
#define __ETK_ARC_GENERATOR_H__

#include <etk/interface/Rect.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EArcGenerator {
public:
	EArcGenerator(EPoint center, float xRadius, float yRadius, EPoint start, EPoint end);

	bool Start(eint32 &x, eint32 &y, eint32 &step, eint32 &pixels, bool &both, bool isLoopX = true, float pixel_size = 1);
	bool Next(eint32 &next, eint32 &pixels, bool &both);

private:
	EPoint fCenter;
	EPoint fRadius;
	EPoint fStart;
	EPoint fEnd;

	eint32 fStep;
	bool fIsLoopX;

	EPoint fRadius2;
	EPoint _fRadius;
	EPoint _fStart;
	EPoint _fEnd;
	float fDeltaNext;

	eint32 _fCenterX;
	eint32 _fCenterY;
	eint32 _fRadiusX;
	eint32 _fStartX;
	eint32 _fStartY;
	eint32 _fEndX;
	eint32 _fEndY;
	eint32 _X;
	eint32 _Y;
};

#endif /* __cplusplus */

#endif /* __ETK_ARC_GENERATOR_H__ */

