/* --------------------------------------------------------------------------
 * 
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 * 
 * $COPYING
 *
 * File: LineGenerator.h
 * Description: ELineGenerator --- Pixel generator for zero-width-line-drawing
 * 
 * --------------------------------------------------------------------------*/

#ifndef __ETK_LINE_GENERATOR_H__
#define __ETK_LINE_GENERATOR_H__

#include <etk/interface/Rect.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ELineGenerator {
public:
	ELineGenerator(EPoint start, EPoint end);

	bool Start(eint32 &x, eint32 &y, eint32 &step, eint32 &pixels, bool isLoopX = true, float pixel_size = 1);
	bool Next(eint32 &next, eint32 &pixels);

private:
	EPoint fStart;
	EPoint fEnd;

	euint8 fDirection;
	eint32 fStep;
	eint32 fStepOther;
	bool fIsLoopX;

	float fEltaNext;
	float fEltaNextAbs;
	float fDeltaElta;

	void InitDirection();
};

#endif /* __cplusplus */

#endif /* __ETK_LINE_GENERATOR_H__ */

