#ifndef __ETK_DIRECTORY_H__
#define __ETK_DIRECTORY_H__ 

#include <etk/storage/Entry.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EDirectory {
public:
	EDirectory();
	EDirectory(const char *path);
	virtual ~EDirectory();

	e_status_t	InitCheck() const;
	e_status_t	SetTo(const char *path);
	void		Unset();

	e_status_t	GetEntry(EEntry *entry) const;
	e_status_t	GetNextEntry(EEntry *entry, bool traverse = false);
	e_status_t	Rewind();
	eint32		CountEntries();

private:
	void *fDir;
	char *fName;
};

#endif /* __cplusplus */

#endif /* __ETK_DIRECTORY_H__ */

