#ifndef __ETK_ENTRY_H__
#define __ETK_ENTRY_H__ 

#include <etk/storage/Path.h>

#ifdef __cplusplus /* Just for C++ */

class EDirectory;

class _IMPEXP_ETK EEntry {
public:
	EEntry();
	EEntry(const char *path, bool traverse = false);
	virtual ~EEntry();

	e_status_t	SetTo(const char *path, bool traverse = false);
	void		Unset();

	e_status_t	InitCheck() const;

	bool		Exists() const;
	e_status_t	GetPath(EPath *path) const;

private:
	friend class EDirectory;

	char *fName;
};

#endif /* __cplusplus */

#endif /* __ETK_ENTRY_H__ */

