#ifndef __ETK_PATH_H__
#define __ETK_PATH_H__ 

#include <etk/support/SupportDefs.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EPath {
public:
	EPath();
	EPath(const char *dir, const char *leaf = NULL, bool normalize = false);
	EPath(const EPath &path);
	virtual ~EPath();

	e_status_t	SetTo(const char *dir, const char *leaf = NULL, bool normalize = false);
	e_status_t	Append(const char *path, bool normalize = false);
	void		Unset();

	const char	*Path() const;
	const char	*Leaf() const;

	e_status_t	GetParent(EPath *parent) const;

	bool		operator==(const EPath &path) const;
	bool		operator==(const char *path) const;
	bool		operator!=(const EPath &path) const;
	bool		operator!=(const char *path) const;
	EPath&		operator=(const EPath &path);
	EPath&		operator=(const char *path);

private:
	char *fPath;
};

#endif /* __cplusplus */

#endif /* __ETK_PATH_H__ */

