#ifndef __ETK_STORAGE_DEFS_H__
#define __ETK_STORAGE_DEFS_H__

#include <etk/support/SupportDefs.h>

typedef eint32	e_dev_t;

/* open_mode */
enum {
	E_READ_ONLY		=	0x00,	/* read only */
	E_WRITE_ONLY		=	0x01,	/* write only */
	E_READ_WRITE		=	0x02,	/* read and write */
	E_FAIL_IF_EXISTS	=	0x04,	/* exclusive create */
	E_CREATE_FILE		=	0x08,	/* create the file */
	E_ERASE_FILE		=	0x10,	/* erase the file's data */
	E_OPEN_AT_END		=	0x20,	/* point to the end of the data */
};

/* access_mode */
enum {
	E_USER_READ		=	0x01,
	E_USER_WRITE		=	0x02,
	E_USER_EXEC		=	0x04,
	E_USER_ALL		=	0x07,
	E_GROUP_READ		=	0x08,
	E_GROUP_WRITE		=	0x10,
	E_GROUP_EXEC		=	0x20,
	E_GROUP_ALL		=	0x38,
	E_OTHERS_READ		=	0x40,
	E_OTHERS_WRITE		=	0x80,
	E_OTHERS_EXEC		=	0x0100,
	E_OTHERS_ALL		=	0x01c0,
};

/* seek_mode */
enum {
	E_SEEK_SET = 0,
	E_SEEK_CUR,
	E_SEEK_END,
};

#endif /* __ETK_STORAGE_DEFS_H__ */

