#ifndef __ETK_VOLUME_H__
#define __ETK_VOLUME_H__

#include <etk/storage/StorageDefs.h>
#include <etk/storage/Directory.h>
#include <etk/support/String.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EVolume {
public:
	EVolume();
	EVolume(e_dev_t dev);
	EVolume(const EVolume &from);
	virtual ~EVolume();

	e_status_t	InitCheck() const;
	e_status_t	SetTo(e_dev_t dev);
	void		Unset();

	e_dev_t		Device() const;

	e_status_t	GetName(char *name, size_t nameSize) const;
	e_status_t	GetName(EString *name) const;
	e_status_t	SetName(const char *name);

	e_status_t	GetRootDirectory(EDirectory *dir) const;

	bool		operator==(const EVolume &vol) const;
	bool		operator!=(const EVolume &vol) const;
	EVolume&	operator=(const EVolume &vol);

private:
	e_dev_t fDevice;
	void *fData;
};

#endif /* __cplusplus */

#endif /* __ETK_VOLUME_H__ */

