#ifndef __ETK_AUTOLOCK_H__
#define __ETK_AUTOLOCK_H__

#ifdef __cplusplus /* Just for C++ */

template<class C>
class EAutolock
{
public:
	EAutolock(C *target)
	{
		fLocker = target;
		fLocked = (fLocker ? fLocker->Lock() : false);
	}

	EAutolock(C &target)
	{
		fLocker = &target;
		fLocked = fLocker->Lock();
	}

	~EAutolock()
	{
		if(fLocked && fLocker) fLocker->Unlock();
	}

	bool IsLocked() const
	{
		return fLocked;
	}

	C* Target() const
	{
		return fLocker;
	}

private:
	bool fLocked;
	C* fLocker;
};

#endif /* __cplusplus */

#endif /* __ETK_AUTOLOCK_H__ */


