#ifndef __ETK_SIMPLE_XML_PARSER_H__
#define __ETK_SIMPLE_XML_PARSER_H__

#include <etk/support/List.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ESimpleXmlNode {
public:
	ESimpleXmlNode(const char *name, const char *content = NULL);
	~ESimpleXmlNode();

	const char		*Name() const;
	void			SetName(const char *name);

	const char		*Content() const;
	void			SetContent(const char *content);

	const char		*AttributeAt(eint32 index, const char** attr_content = NULL) const;
	bool			AddAttribute(const char *name, const char *content, bool replace_content = true);
	bool			RemoveAttribute(const char *name);
	eint32			FindAttribute(const char *name, eint32 fromIndex = 0) const;
	eint32			CountAttributes() const;

	ESimpleXmlNode		*NodeAt(eint32 index) const;
	bool			AddNode(ESimpleXmlNode *node);
	bool			RemoveNode(ESimpleXmlNode *node);
	bool			RemoveSelf();
	eint32			FindNode(const char *name, eint32 fromIndex = 0) const;
	eint32			CountNodes() const;
	ESimpleXmlNode		*SuperNode() const;

	void			PrintToStream() const;

private:
	char *fName;
	char *fContent;
	EList fAttributes;
	EList fNodes;

	ESimpleXmlNode *fSuperNode;
};


_IMPEXP_ETK e_status_t etk_parse_simple_xml(const char *simple_xml_buffer, ESimpleXmlNode *node);


#endif /* __cplusplus */

#endif /* __ETK_SIMPLE_XML_PARSER_H__ */

